import _winreg, subprocess

BASEPATH = "SYSTEM\\CurrentControlSet\\Enum\\USB\\VID_1366&"
PIDS = ["PID_0105", "PID_1015", "PID_0101"]
PIDNOCOM = ["PID_0101", ""]

def getPID(snr):
    for pid in PIDS:
        try:
            key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, BASEPATH + pid + "\\000" + snr)
            _winreg.CloseKey(key)
            return pid
        except WindowsError:
            continue
    return ""

def getPIDPrefix(snr):
    pid = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, BASEPATH + getPID(snr) + "\\000" + snr)
    return str(_winreg.QueryValueEx(pid, "ParentIdPrefix")[0])
    
def getComPort(snr):
    pid = getPID(snr)
    if  pid in PIDNOCOM:
        return ""
    comPortEntryKey = BASEPATH + pid + "&MI_00\\" + getPIDPrefix(snr) + "&0000"
    comPortEntry = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, comPortEntryKey)
    comPortValue = str(_winreg.QueryValueEx(comPortEntry, "FriendlyName")[0]) 
    return comPortValue[comPortValue.index('(')+1: comPortValue.index(')')]

def getConnectedJlinkSnrs():
    def isNumber(n):
        try:
            int(n)
            return True
        except ValueError:
            return False

    devList = subprocess.check_output("nrfjprog -i" ,stderr=subprocess.STDOUT,shell=True).split('\r\n')
    for i in devList:
        if not isNumber(i):
            devList.remove(i)
    return devList

if __name__ == "__main__":
    devList = getConnectedJlinkSnrs()
    for i in devList:
        print i + " " + getComPort(i)
    raw_input("...")